<?php

namespace EventPortal\Tests\Support\Factories;

use Carbon\Carbon;
use EventPortal\Domain\Agenda\Models\Agenda;
use EventPortal\Domain\Agenda\Models\Pathway;
use EventPortal\Domain\Event\Models\Event;

class AgendaFactory
{
    /** @var Event */
    public $event;

    /** @var Agenda */
    public $agenda;

    public function __construct(Carbon $date, Event $event)
    {
        $this->event = $event;
        $this->agenda = $this->create($date, $event);
    }

    public static function make(Carbon $date, Event $event): self
    {
        return new self($date, $event);
    }

    public function createSession(Pathway $pathway, callable $callable): self
    {
        $callable(new SessionFactory($this->agenda, $pathway));

        return $this;
    }

    private function create(Carbon $date, Event $event): Agenda
    {
        return Agenda::create([
            'date' => $date,
            'event_id' => $event->id,
        ]);
    }
}
